searchNodes=[{"ref":"Lapin.html","title":"Lapin","type":"module","doc":"Lapin, an Elixir RabbitMQ client Comprehensive documentation is available here."},{"ref":"Lapin.html#t:config/0","title":"Lapin.config/0","type":"type","doc":"Lapin configuration"},{"ref":"Lapin.Channel.html","title":"Lapin.Channel","type":"module","doc":"Lapin Channel handling"},{"ref":"Lapin.Channel.html#ack/2","title":"Lapin.Channel.ack/2","type":"function","doc":"ACK message consumption"},{"ref":"Lapin.Channel.html#confirm/1","title":"Lapin.Channel.confirm/1","type":"function","doc":"Wait for publish confirmation"},{"ref":"Lapin.Channel.html#create/2","title":"Lapin.Channel.create/2","type":"function","doc":"Creates a channel from configuration"},{"ref":"Lapin.Channel.html#get/2","title":"Lapin.Channel.get/2","type":"function","doc":"Find channel by consumer_tag"},{"ref":"Lapin.Channel.html#get/4","title":"Lapin.Channel.get/4","type":"function","doc":"Find channel by exchange and routing key"},{"ref":"Lapin.Channel.html#publish/5","title":"Lapin.Channel.publish/5","type":"function","doc":"Publish message"},{"ref":"Lapin.Channel.html#reject/3","title":"Lapin.Channel.reject/3","type":"function","doc":"Reject message"},{"ref":"Lapin.Channel.html#t:config/0","title":"Lapin.Channel.config/0","type":"type","doc":"Channel configuration The following keys are supported: role: channel role (atom), allowed values are: :consumer: Receives messages from the channel via Lapin.Connection callbacks :producer: Can publish messages to che channel :passive: Used to declare channel configuration, can&#39;t receive nor publish pattern: channel pattern (module using the Lapin.Pattern behaviour) exchange: broker exchange (String.t) queue: broker queue (String.t) If using the Lapin.Pattern.Config default implementation, the following keys are also supported: consumer_ack: send consumer ack (boolean), default: false consumer_prefetch cosumer prefetch (integer | nil), default: nil exchange_type: declare type of the exchange (:direct, :fanout, :topic), default: :direct exchange_durable: declare exchange as durable (boolean), default: true publisher_confirm: expect RabbitMQ publish confirms (boolean), default: false publisher_mandatory: messages published as mandatory by default (boolean), deafault: false publisher_persistent: messages published as persistent by default (boolean), deafault: false queue_arguments: queue arguments (list of {string, type, value}), default: [] queue_durable: declare queue as durable (boolean), default: true routing_key: routing_key for bindings (string), default: &quot;&quot;"},{"ref":"Lapin.Channel.html#t:consumer_prefetch/0","title":"Lapin.Channel.consumer_prefetch/0","type":"type","doc":"Consumer Prefetch"},{"ref":"Lapin.Channel.html#t:consumer_tag/0","title":"Lapin.Channel.consumer_tag/0","type":"type","doc":"Consumer Tag"},{"ref":"Lapin.Channel.html#t:exchange/0","title":"Lapin.Channel.exchange/0","type":"type","doc":"Exchange name"},{"ref":"Lapin.Channel.html#t:queue/0","title":"Lapin.Channel.queue/0","type":"type","doc":"Queue name"},{"ref":"Lapin.Channel.html#t:queue_arguments/0","title":"Lapin.Channel.queue_arguments/0","type":"type","doc":"Queue Arguments"},{"ref":"Lapin.Channel.html#t:role/0","title":"Lapin.Channel.role/0","type":"type","doc":"Channel role"},{"ref":"Lapin.Channel.html#t:routing_key/0","title":"Lapin.Channel.routing_key/0","type":"type","doc":"Routing key"},{"ref":"Lapin.Channel.html#t:t/0","title":"Lapin.Channel.t/0","type":"type","doc":""},{"ref":"Lapin.Connection.html","title":"Lapin.Connection","type":"behaviour","doc":"RabbitMQ connection handler This module handles the RabbitMQ connection. It also provides a behaviour for worker module implementation. The worker module should use the Lapin.Connection behaviour and implement the callbacks it needs. When using the Lapin.Connection behaviour a publish/4 function is injected in the worker module as a shortcut to the Lapin.Connection.publish/5 function which removes the need for passing in the connection and is publicly callable to publish messages on the connection configured for the implementing module."},{"ref":"Lapin.Connection.html#close/1","title":"Lapin.Connection.close/1","type":"function","doc":"Closes the connection"},{"ref":"Lapin.Connection.html#c:handle_cancel/1","title":"Lapin.Connection.handle_cancel/1","type":"callback","doc":"Called when receiving a basic.cancel from the broker."},{"ref":"Lapin.Connection.html#c:handle_cancel_ok/1","title":"Lapin.Connection.handle_cancel_ok/1","type":"callback","doc":"Called when receiving a basic.cancel_ok from the broker."},{"ref":"Lapin.Connection.html#c:handle_consume_ok/1","title":"Lapin.Connection.handle_consume_ok/1","type":"callback","doc":"Called when receiving a basic.consume_ok from the broker. This signals successul registration as a consumer."},{"ref":"Lapin.Connection.html#c:handle_deliver/2","title":"Lapin.Connection.handle_deliver/2","type":"callback","doc":"Called when receiving a basic.deliver from the broker. Return values from this callback determine message acknowledgement: :ok: Message was processed by the consumer and should be removed from queue {:reject, reason}: Message was not processed and should be rejected Any other return value requeues the message to prevent data loss. A crash in the callback code will however reject the message to prevent loops if the message was already delivered before. The reason term can be used by the application to signal the reason of rejection and is logged in debug."},{"ref":"Lapin.Connection.html#c:handle_publish/2","title":"Lapin.Connection.handle_publish/2","type":"callback","doc":"Called when completing a basic.publish with the broker. Message transmission to the broker is successful when this callback is called."},{"ref":"Lapin.Connection.html#c:handle_return/2","title":"Lapin.Connection.handle_return/2","type":"callback","doc":"Called when receiving a basic.return from the broker. This signals an undeliverable returned message from the broker."},{"ref":"Lapin.Connection.html#c:payload_for/2","title":"Lapin.Connection.payload_for/2","type":"callback","doc":"Called before handle_deliver/2 to get the payload type. Should return a data type instance to decode the payload into. A Lapin.Message.Payload implementation must be provided for this type. The default implementation leaves the payload unaltered."},{"ref":"Lapin.Connection.html#publish/5","title":"Lapin.Connection.publish/5","type":"function","doc":"Publishes a message to the specified exchange with the given routing_key"},{"ref":"Lapin.Connection.html#start_link/2","title":"Lapin.Connection.start_link/2","type":"function","doc":"Starts a Lapin.Connection with the specified configuration"},{"ref":"Lapin.Connection.html#t:config/0","title":"Lapin.Connection.config/0","type":"type","doc":"Connection configuration The following keys are supported: module: module using the Lapin.Connection behaviour uri: AMQP URI (String.t | URI.t) host: broker hostname (string | charlist), default: &#39;localhost&#39; port: broker port (string | integer), default: 5672 virtual_host: broker vhost (string), default: &quot;/&quot; username: username (string) password: password (string) auth_mechanisms: broker auth_mechanisms ([:amqplain | :external | :plain]), default: amqp_client default ssl_options: ssl options ([:ssl:ssl_option]), default: none channels: channels to configure ([Channel.config]), default: []"},{"ref":"Lapin.Connection.html#t:on_callback/0","title":"Lapin.Connection.on_callback/0","type":"type","doc":"Callback result"},{"ref":"Lapin.Connection.html#t:on_deliver/0","title":"Lapin.Connection.on_deliver/0","type":"type","doc":"handle_deliver/2 callback result"},{"ref":"Lapin.Connection.html#t:reason/0","title":"Lapin.Connection.reason/0","type":"type","doc":"Reason for message rejection"},{"ref":"Lapin.Connection.html#t:t/0","title":"Lapin.Connection.t/0","type":"type","doc":"Connection"},{"ref":"Lapin.Connection.Supervisor.html","title":"Lapin.Connection.Supervisor","type":"module","doc":"Lapin Connections Supervisor"},{"ref":"Lapin.Connection.Supervisor.html#child_spec/1","title":"Lapin.Connection.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Lapin.Connection.Supervisor.html#init/1","title":"Lapin.Connection.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Lapin.Connection.Supervisor.html#start_link/1","title":"Lapin.Connection.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Lapin.Message.html","title":"Lapin.Message","type":"module","doc":"Lapin Message struct"},{"ref":"Lapin.Message.html#t:meta/0","title":"Lapin.Message.meta/0","type":"type","doc":"Message metadata"},{"ref":"Lapin.Message.html#t:payload/0","title":"Lapin.Message.payload/0","type":"type","doc":"Message payload"},{"ref":"Lapin.Message.html#t:t/0","title":"Lapin.Message.t/0","type":"type","doc":"Lapin Message container"},{"ref":"Lapin.Message.Payload.html","title":"Lapin.Message.Payload","type":"protocol","doc":"You can use this protocol to implement a custom message payload transformation. For example you could impelment a JSON message with a predefined structure by first implementing a struct for your payload: defmodule Example.Payload do defstruct [a: &quot;a&quot;, b: &quot;b&quot;, c: nil] end and then providing an implementation of Lapin.Message.Payload for it: defimpl Lapin.Message.Payload, for: Example.Payload do def content_type(_payload), do: &quot;application/json&quot; def encode(payload), do: Poison.encode(payload) def decode_into(payload, data), do: Poison.decode(data, as: payload) end Please note you will need to add the poison library as a dependency on in your project mix.exs for this to work. Lapin will automatically encode and set the content-type property on publish. To decode messages before consuming, implement the payload_for/2 callback of Lapin.Connection and return an instance of the payload to decode into. defmodule Example.Connection do def payload_for(_channel, _message), do: %Example.Payload{} end The default implementation simply returns the unaltered binary data and sets the message content-type property to nil."},{"ref":"Lapin.Message.Payload.html#content_type/1","title":"Lapin.Message.Payload.content_type/1","type":"function","doc":"Returns the message content-type"},{"ref":"Lapin.Message.Payload.html#decode_into/2","title":"Lapin.Message.Payload.decode_into/2","type":"function","doc":"Returns the payload with message data decoded"},{"ref":"Lapin.Message.Payload.html#encode/1","title":"Lapin.Message.Payload.encode/1","type":"function","doc":"Returns the encoded payload body"},{"ref":"Lapin.Message.Payload.html#t:content_type/0","title":"Lapin.Message.Payload.content_type/0","type":"type","doc":"MIME content-type as defined by RFC 2045"},{"ref":"Lapin.Message.Payload.html#t:on_decode/0","title":"Lapin.Message.Payload.on_decode/0","type":"type","doc":"Decode function return values"},{"ref":"Lapin.Message.Payload.html#t:on_encode/0","title":"Lapin.Message.Payload.on_encode/0","type":"type","doc":"Encode function return values"},{"ref":"Lapin.Message.Payload.html#t:t/0","title":"Lapin.Message.Payload.t/0","type":"type","doc":"Data type implementing the Lapin.Message.Payload protocol"},{"ref":"Lapin.Pattern.html","title":"Lapin.Pattern","type":"behaviour","doc":"Extensible behaviour to define pattern modules. Lapin provides a number of submodules which impelment the patterns found in the RabbitMQ Tutorials. defmodule ExampleApp.SomePatter do use Lapin.Pattern [... callbacks implementation ...] end"},{"ref":"Lapin.Pattern.html#c:consumer_ack/1","title":"Lapin.Pattern.consumer_ack/1","type":"callback","doc":"Consumer acknowledgements enabled"},{"ref":"Lapin.Pattern.html#c:consumer_prefetch/1","title":"Lapin.Pattern.consumer_prefetch/1","type":"callback","doc":"Consumer message prefetch count"},{"ref":"Lapin.Pattern.html#c:exchange_durable/1","title":"Lapin.Pattern.exchange_durable/1","type":"callback","doc":"Declare exchange durable"},{"ref":"Lapin.Pattern.html#c:exchange_type/1","title":"Lapin.Pattern.exchange_type/1","type":"callback","doc":"Declare exchange type"},{"ref":"Lapin.Pattern.html#c:publisher_confirm/1","title":"Lapin.Pattern.publisher_confirm/1","type":"callback","doc":"Request publisher confirms (RabbitMQ only)"},{"ref":"Lapin.Pattern.html#c:publisher_mandatory/1","title":"Lapin.Pattern.publisher_mandatory/1","type":"callback","doc":"Request message mandatory routing when publishing"},{"ref":"Lapin.Pattern.html#c:publisher_persistent/1","title":"Lapin.Pattern.publisher_persistent/1","type":"callback","doc":"Request message persistence when publishing"},{"ref":"Lapin.Pattern.html#c:queue_arguments/1","title":"Lapin.Pattern.queue_arguments/1","type":"callback","doc":"Declare queue arguments"},{"ref":"Lapin.Pattern.html#c:queue_durable/1","title":"Lapin.Pattern.queue_durable/1","type":"callback","doc":"Declare queue durable"},{"ref":"Lapin.Pattern.html#c:routing_key/1","title":"Lapin.Pattern.routing_key/1","type":"callback","doc":"Bind queue to routing_key"},{"ref":"Lapin.Pattern.html#t:t/0","title":"Lapin.Pattern.t/0","type":"type","doc":"Lapin Pattern Behaviour"},{"ref":"Lapin.Pattern.Config.html","title":"Lapin.Pattern.Config","type":"module","doc":"Default Lapin.Pattern behaviour implementation for channels Used by default to read settings from the static configuration file and provide defaults for unspecified settings."},{"ref":"Lapin.Pattern.Config.html#consumer_ack/1","title":"Lapin.Pattern.Config.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.Config.html#consumer_prefetch/1","title":"Lapin.Pattern.Config.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.Config.html#exchange_durable/1","title":"Lapin.Pattern.Config.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.Config.html#exchange_type/1","title":"Lapin.Pattern.Config.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.Config.html#publisher_confirm/1","title":"Lapin.Pattern.Config.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.Config.html#publisher_mandatory/1","title":"Lapin.Pattern.Config.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.Config.html#publisher_persistent/1","title":"Lapin.Pattern.Config.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.Config.html#queue_arguments/1","title":"Lapin.Pattern.Config.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.Config.html#queue_durable/1","title":"Lapin.Pattern.Config.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.Config.html#routing_key/1","title":"Lapin.Pattern.Config.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.HelloWorld.html","title":"Lapin.Pattern.HelloWorld","type":"module","doc":"Lapin.Pattern implementation for the Hello World RabbitMQ pattern."},{"ref":"Lapin.Pattern.HelloWorld.html#consumer_ack/1","title":"Lapin.Pattern.HelloWorld.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.HelloWorld.html#consumer_prefetch/1","title":"Lapin.Pattern.HelloWorld.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.HelloWorld.html#exchange_durable/1","title":"Lapin.Pattern.HelloWorld.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.HelloWorld.html#exchange_type/1","title":"Lapin.Pattern.HelloWorld.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.HelloWorld.html#publisher_confirm/1","title":"Lapin.Pattern.HelloWorld.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.HelloWorld.html#publisher_mandatory/1","title":"Lapin.Pattern.HelloWorld.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.HelloWorld.html#publisher_persistent/1","title":"Lapin.Pattern.HelloWorld.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.HelloWorld.html#queue_arguments/1","title":"Lapin.Pattern.HelloWorld.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.HelloWorld.html#queue_durable/1","title":"Lapin.Pattern.HelloWorld.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.HelloWorld.html#routing_key/1","title":"Lapin.Pattern.HelloWorld.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.PubSub.html","title":"Lapin.Pattern.PubSub","type":"module","doc":"Lapin.Pattern implementation for the Publish/Subscribe RabbitMQ pattern."},{"ref":"Lapin.Pattern.PubSub.html#consumer_ack/1","title":"Lapin.Pattern.PubSub.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.PubSub.html#consumer_prefetch/1","title":"Lapin.Pattern.PubSub.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.PubSub.html#exchange_durable/1","title":"Lapin.Pattern.PubSub.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.PubSub.html#exchange_type/1","title":"Lapin.Pattern.PubSub.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.PubSub.html#publisher_confirm/1","title":"Lapin.Pattern.PubSub.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.PubSub.html#publisher_mandatory/1","title":"Lapin.Pattern.PubSub.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.PubSub.html#publisher_persistent/1","title":"Lapin.Pattern.PubSub.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.PubSub.html#queue_arguments/1","title":"Lapin.Pattern.PubSub.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.PubSub.html#queue_durable/1","title":"Lapin.Pattern.PubSub.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.PubSub.html#routing_key/1","title":"Lapin.Pattern.PubSub.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.RPC.html","title":"Lapin.Pattern.RPC","type":"module","doc":"Lapin.Pattern implementation for the RPC RabbitMQ pattern."},{"ref":"Lapin.Pattern.RPC.html#consumer_ack/1","title":"Lapin.Pattern.RPC.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.RPC.html#consumer_prefetch/1","title":"Lapin.Pattern.RPC.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.RPC.html#exchange_durable/1","title":"Lapin.Pattern.RPC.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.RPC.html#exchange_type/1","title":"Lapin.Pattern.RPC.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.RPC.html#publisher_confirm/1","title":"Lapin.Pattern.RPC.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.RPC.html#publisher_mandatory/1","title":"Lapin.Pattern.RPC.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.RPC.html#publisher_persistent/1","title":"Lapin.Pattern.RPC.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.RPC.html#queue_arguments/1","title":"Lapin.Pattern.RPC.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.RPC.html#queue_durable/1","title":"Lapin.Pattern.RPC.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.RPC.html#routing_key/1","title":"Lapin.Pattern.RPC.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.Routing.html","title":"Lapin.Pattern.Routing","type":"module","doc":"Lapin.Pattern implementation for the Routing RabbitMQ pattern."},{"ref":"Lapin.Pattern.Routing.html#consumer_ack/1","title":"Lapin.Pattern.Routing.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.Routing.html#consumer_prefetch/1","title":"Lapin.Pattern.Routing.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.Routing.html#exchange_durable/1","title":"Lapin.Pattern.Routing.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.Routing.html#exchange_type/1","title":"Lapin.Pattern.Routing.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.Routing.html#publisher_confirm/1","title":"Lapin.Pattern.Routing.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.Routing.html#publisher_mandatory/1","title":"Lapin.Pattern.Routing.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.Routing.html#publisher_persistent/1","title":"Lapin.Pattern.Routing.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.Routing.html#queue_arguments/1","title":"Lapin.Pattern.Routing.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.Routing.html#queue_durable/1","title":"Lapin.Pattern.Routing.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.Routing.html#routing_key/1","title":"Lapin.Pattern.Routing.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.Topic.html","title":"Lapin.Pattern.Topic","type":"module","doc":"Lapin.Pattern implementation for the Topics RabbitMQ pattern."},{"ref":"Lapin.Pattern.Topic.html#consumer_ack/1","title":"Lapin.Pattern.Topic.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.Topic.html#consumer_prefetch/1","title":"Lapin.Pattern.Topic.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.Topic.html#exchange_durable/1","title":"Lapin.Pattern.Topic.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.Topic.html#exchange_type/1","title":"Lapin.Pattern.Topic.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.Topic.html#publisher_confirm/1","title":"Lapin.Pattern.Topic.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.Topic.html#publisher_mandatory/1","title":"Lapin.Pattern.Topic.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.Topic.html#publisher_persistent/1","title":"Lapin.Pattern.Topic.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.Topic.html#queue_arguments/1","title":"Lapin.Pattern.Topic.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.Topic.html#queue_durable/1","title":"Lapin.Pattern.Topic.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.Topic.html#routing_key/1","title":"Lapin.Pattern.Topic.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Pattern.WorkQueue.html","title":"Lapin.Pattern.WorkQueue","type":"module","doc":"Lapin.Pattern implementation for the Work Queues RabbitMQ pattern."},{"ref":"Lapin.Pattern.WorkQueue.html#consumer_ack/1","title":"Lapin.Pattern.WorkQueue.consumer_ack/1","type":"function","doc":"Consumer acknowledgements enabled Callback implementation for Lapin.Pattern.consumer_ack/1."},{"ref":"Lapin.Pattern.WorkQueue.html#consumer_prefetch/1","title":"Lapin.Pattern.WorkQueue.consumer_prefetch/1","type":"function","doc":"Consumer message prefetch count Callback implementation for Lapin.Pattern.consumer_prefetch/1."},{"ref":"Lapin.Pattern.WorkQueue.html#exchange_durable/1","title":"Lapin.Pattern.WorkQueue.exchange_durable/1","type":"function","doc":"Declare exchange durable Callback implementation for Lapin.Pattern.exchange_durable/1."},{"ref":"Lapin.Pattern.WorkQueue.html#exchange_type/1","title":"Lapin.Pattern.WorkQueue.exchange_type/1","type":"function","doc":"Declare exchange type Callback implementation for Lapin.Pattern.exchange_type/1."},{"ref":"Lapin.Pattern.WorkQueue.html#publisher_confirm/1","title":"Lapin.Pattern.WorkQueue.publisher_confirm/1","type":"function","doc":"Request publisher confirms (RabbitMQ only) Callback implementation for Lapin.Pattern.publisher_confirm/1."},{"ref":"Lapin.Pattern.WorkQueue.html#publisher_mandatory/1","title":"Lapin.Pattern.WorkQueue.publisher_mandatory/1","type":"function","doc":"Request message mandatory routing when publishing Callback implementation for Lapin.Pattern.publisher_mandatory/1."},{"ref":"Lapin.Pattern.WorkQueue.html#publisher_persistent/1","title":"Lapin.Pattern.WorkQueue.publisher_persistent/1","type":"function","doc":"Request message persistence when publishing Callback implementation for Lapin.Pattern.publisher_persistent/1."},{"ref":"Lapin.Pattern.WorkQueue.html#queue_arguments/1","title":"Lapin.Pattern.WorkQueue.queue_arguments/1","type":"function","doc":"Declare queue arguments Callback implementation for Lapin.Pattern.queue_arguments/1."},{"ref":"Lapin.Pattern.WorkQueue.html#queue_durable/1","title":"Lapin.Pattern.WorkQueue.queue_durable/1","type":"function","doc":"Declare queue durable Callback implementation for Lapin.Pattern.queue_durable/1."},{"ref":"Lapin.Pattern.WorkQueue.html#routing_key/1","title":"Lapin.Pattern.WorkQueue.routing_key/1","type":"function","doc":"Bind queue to routing_key Callback implementation for Lapin.Pattern.routing_key/1."},{"ref":"Lapin.Utils.html","title":"Lapin.Utils","type":"module","doc":"Misc utility functions"},{"ref":"Lapin.Utils.html#check_mandatory_params/2","title":"Lapin.Utils.check_mandatory_params/2","type":"function","doc":"Checks the cconfiguration contains some keys"},{"ref":"main.html","title":"Lapin, a RabbitMQ client for Elixir","type":"extras","doc":"Lapin, a RabbitMQ client for Elixir"},{"ref":"main.html#description","title":"Lapin, a RabbitMQ client for Elixir - Description","type":"extras","doc":"Lapin is a RabbitMQ client for Elixir which abstracts away a lot of the complexities of interacting with an AMQP broker. While some advanced features, like publisher confirms, are tied to RabbitMQ implementation specific extensions, Lapin should play well with other broker implementations conforming to the AMQP 0.9.1 specification."},{"ref":"main.html#installation","title":"Lapin, a RabbitMQ client for Elixir - Installation","type":"extras","doc":"Just add Lapin as a dependency to your mix.exs: defp deps() do [{:lapin, &quot;&gt;= 0.0.0&quot;}] end"},{"ref":"main.html#quick-start","title":"Lapin, a RabbitMQ client for Elixir - Quick Start","type":"extras","doc":"If you are impatient to try Lapin out, just tweak this basic configuration example: config :lapin, :connections, [ [ module: ExampleApp.Worker channels: [ [ role: :consumer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ], [ role: :producer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ] ] ] ] and define your worker module as follows: defmodule ExampleApp.Worker do use Lapin.Connection end To test your setup make sure RabbitMQ is running and configured correctly, then run your application with iex -S mix and publish a message: ... iex(1)&gt; ExampleApp.Worker.publish(&quot;some_exchange&quot;, &quot;routing_key&quot;, &quot;payload&quot;) [debug] Published %Lapin.Message{meta: %{content_type: nil, mandatory: false, persistent: false}, payload: &quot;payload&quot;} on %Lap in.Channel{amqp_channel: %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.212.0&gt;}, pid: #PID&lt;0.221.0&gt;}, config: [role: :producer, e xchange: &quot;test_exchange&quot;, queue: &quot;test_queue&quot;], consumer_tag: nil, exchange: &quot;some_exchange&quot;, pattern: Lapin.Pattern.Config, queue: &quot;some_queue&quot;, role: :producer, routing_key: &quot;routing_key&quot;} :ok [debug] Consuming message 1 [debug] Consumed message 1 successfully, ACK sent ... Read on to learn how easy it is to tweak this basic configuration."},{"ref":"main.html#configuration","title":"Lapin, a RabbitMQ client for Elixir - Configuration","type":"extras","doc":"You can configure multiple connections. Each connection is backed by a worker which can implement a few callbacks to publish/consume messages and handle other type of events from the broker. Each connection can have one or more channels, each one either consuming OR publishing messages. The default implementation of all callbacks simply returns :ok. You need to configure a worker module for all connections. To implement a worker module, define a module and use the Lapin.Connection behaviour, then add it under the module key in your channel configuration. For details on implementing Lapin worker modules check out the Lapin.Connection behaviour documentation. At a minimum, you need to configure a module for each connection and role, exchange and queue for each channel. You can find the complete list of connection configuration settings in the in Lapin.Connection config type specification. Advanced channel behaviour can be configured in two ways. One-shot, static channel configuration If you are fine with a one shot configuration of your channels, you can specify any settings from the Lapin.Channel config type specification directly in your channel configurations and use the default Lapin.Pattern implementation. This is quick and easy way to start. lib/example_app/some_worker.ex: defmodule ExampleApp.Worker do use Lapin.Connection end config/config.exs: config :lapin, :connections, [ [ module: ExampleApp.Worker, channels: [ [ role: :consumer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot;, exchange_type: :fanout, queue_durable: false ], [ role: :producer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot;, publisher_persistent: true ] ] ] ] Reusable, static or dynamic channel configuration If you need to configure a lot of channels in the same way, you can use a Lapin.Pattern to define channel settings. A pattern is simply a collection of behaviour callbacks bundled in a module, which you can then reuse in any channel configuration when you need the same kind of interaction pattern. To do this, you need to define your pattern module by use Lapin.Pattern and specifying it in your in your channel configuration under the pattern key. In fact Lapin bundles a few Lapin.Pattern implementations for the RabbitMQ tutorials patterns. lib/example_app/some_pattern.ex: defmodule ExampleApp.Pattern do use Lapin.Pattern def exchange_type(_channel), do: :fanout, def queue_durable(_channel), do: false def publisher_persistent(_channel), do: true end config/config.exs: config :lapin, :connections, [ [ module: ExampleApp.Worker channels: [ [ pattern: ExampleApp.Pattern, role: :consumer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ], [ pattern: ExampleApp.Pattern, role: :producer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ] ] ] ] Since Lapin.Pattern is just a behaviour of overridable callback functions, patterns also allow you to implement any kind of dynamic runtime configuration. Actually, the one-shot static configuration explained earlier is implemented by the default Lapin.Pattern.Config module implementation which tries to read settings from the configuration file and provides sensible defaults if needed."},{"ref":"main.html#usage","title":"Lapin, a RabbitMQ client for Elixir - Usage","type":"extras","doc":"Consuming messages Once you have completed your configuration, connections will be automatically established and channels with a :consumer role will start receiving messages published on the queues they are consuming. You can handle received messages by overriding the Lapin.Connection.handle_deliver/2 callback. The default implementation simply logs messages and returns :ok. defmodule ExampleApp.Worker do use Lapin.Connection def handle_deliver(channel, message) do Logger.debug fn -&gt; &quot;received \#{inspect message} on \#{inspect channel}&quot; end :ok end end Since messages for all channels on the same connection are received by the same worker module, to dispatch messages to different handling logic you can pattern match on the Channel.config map which contains message routing information. defmodule ExampleApp.Worker do use Lapin.Connection def handle_deliver(%Channel{exchange: &quot;a&quot;, queue: &quot;b&quot;} = channel, message) do Logger.debug fn -&gt; &quot;received \#{inspect message} on \#{inspect channel}&quot; end :ok end def handle_deliver(%Channel{exchange: &quot;c&quot;, queue: &quot;d&quot;} = channel, message) do Logger.debug fn -&gt; &quot;received \#{inspect message} on \#{inspect channel}&quot; end :ok end end Messages are considered to be successfully consumed if the Lapin.Connection.handle_deliver/2 callback returns :ok. See the callback documentation for a complete list of possible values you can return to signal message acknowledgement and rejection to the broker. Publishing messages To publish messages on channels with a :producer role, you can use the publish function injected in your worker module by use Lapin.Connection, or directly call Lapin.Connection.publish/5 by passing your worker module as a connection. config/config.exs: config :lapin, :connections, [ [ module: ExampleApp.Worker, channels: [ [ role: :producer, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ] ] ] ] Using the worker module implementation: :ok = ExampleApp.Worker.publish(&quot;some_exchange&quot;, &quot;routing_key&quot;, &quot;payload&quot;, []) Via Lapin.Connection by passing the worker module as the connection: :ok = Lapin.Connection.publish(ExampleApp.Worker, &quot;some_exchange&quot;, &quot;routing_key&quot;, &quot;payload&quot;, []) If you are starting a Lapin.Connection manually, you can also pass the connection pid: {:ok, pid} = Lapin.Connection.start_link([ module: ExampleApp.Worker, channels: [ [ role: :producer, pattern: ExampleApp.Pattern, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ] ] ]) :ok = Lapin.Connection.publish(pid, &quot;some_exchange&quot;, &quot;routing_key&quot;, %Lapin.Message{}, []) Declaring broker configuration If you want to declare exchanges and queues without producing nor consuming messages, you can set channel role to :passive in your channels. This particular role does not allow publishing via messages and does not register with the broker to consume the configured queue. Lapin will just create the channel and declare exchanges, queues and queue bindings, reporting any discrepancies between the configuration and the broker state if there are any. {:ok, pid} = Lapin.Connection.start_link([ module: ExampleApp.Worker, channels: [ [ role: :passive, exchange: &quot;some_exchange&quot;, queue: &quot;some_queue&quot; ] ] ]) {:error, message} = Lapin.Connection.publish(pid, &quot;some_exchange&quot;, &quot;routing_key&quot;, %Lapin.Message{}, []) Message payload encoding Message payload is assumed to be binary by default, and is sent and received unaltered by your code. However, Lapin can handle message encoding and decoding for you. Automatic encoding of the message payload is done by passing a data type other than binary as the payload argument to the publish methods. And by providing an implementation of the Lapin.Message.Payload protocol for your data type. When consuming, the Lapin.Connection.payload_for/2 callback of the worker module allows you to return an instance of the data type you want to perform message decoding into. Again, an implementation of the Lapin.Message.Payload protocol is required for your custom payload data type (e.g. a struct). The Lapin.Message.Payload protocol documentation explains how to implement the required functions, and provides an example JSON to struct implementation."}]